/***************************************************************************
                          level1.cpp  -  description
                             -------------------
    begin                : Tue Nov 26 2002
    copyright            : (C) 2002 by David Brokenshire
    email                : brokenshire@sfu.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "level1.h"
#include "Player.h"

  /*! Constructs the level with a reference to the player that own it.
  */
  Level1::Level1(Player* thePlayer) : Level()
  {
       player = thePlayer;
      // multyCycleDribbleStep  = 0;
  }

  Level1::~Level1()
  {
  }

  /*! This method is the entry point of the level.  It is
      responsible for calling any other methods of the level.
      return of 0 indicates actions selected and in process
      return of 1 indicates finished, no actions selected.
      return of -1 indicates actions not selected (failure)

  */
  LevelStateT Level1::execute()
  {
    char* str = new char[50];
    if (getTimer() == 0)
    { //use setTimer to set the timer (in cycles) for this level.
      //It doesn't necessarily have to be for 5 cycles, it could be
      //variable depending on other factors, like how long we expect
      //our particular task to take (ex. dribbling might take longer than
      //passing)
      setTimer(6000);
    }
    
     //   cout << "Called Level 1" << endl;
    // return multiCycleDribble();
    
    if ( player->formations->getPlayerType() == PT_GOALKEEPER )
    { //player->deMeer5_goalie();
      player->brokenGoalieVersion1();
    }
    else
    { //player->deMeer5();
      //player->brokenPlayerVersion1();
      LevelStateT output = player->generateAction1();
/*
      if ( player->multiCycleDribbleStep > 0 )
         cout << "#" << player->WM->getPlayerNumber()
              << "  count = " << player->multiCycleDribbleStep
              << "  LevelStateT = " << output
              << "  cycle = " << player->WM->getCurrentCycle()
              << endl;
*/       
      return output;
      
    }
    
    return ACTIONS_SELECTED_FINISHED;
        
  }

  /*! This method isused to compose a message about the target area in the form of
      a string
  */
  void Level1::composeTargetAreaString(char* str)
  {
    //Determine if we have the offensive target area or defensive target area
    //this should really be put into a method so we don't have multiple points
    //of change (it currently exists in level3 as well).
    if (str == NULL)
    { str = new char[50];
    }

    //get the side, cheat and use lowercase and uppercase to encode offence or defence
    //respectively
    char side;
    if (player->WM->getSide() == SIDE_LEFT)
    { side = 'l';
    }
    else if (player->WM->getSide() == SIDE_RIGHT)
    { side = 'r';
    }
    else
    { side = 'i';
    }

    //get the target area
    VecPosition target = player->WM->getTargetArea();
    VecPosition leftBottom;
    VecPosition rightTop;

    leftBottom.setVecPosition(target.getX()-10.5,-target.getY()+10.5);
    rightTop.setVecPosition(target.getX()+10.5,-target.getY()-10.5);

    //points that represent target area
    double ux = leftBottom.getX();
    double uy = leftBottom.getY();
    double lx = rightTop.getX();
    double ly = rightTop.getY();

    //
    sprintf(str, "(%c %d %.2f %.2f %.2f %.2f)",side, player->WM->getPlayerNumber(),ux, uy, lx, ly);

}

  
  LevelStateT Level1::multiCycleDribble() //This doesn't really have to return LevelStateT, it could return anything it needed to.
  { //In here you would do whatever it is was needed to select the actions
    //Actions should be added to the queue by this level, either by the
    //methods like this one, or in execute.  So we could:
    player->ACT->putCommandInQueue(player->dribble(90, DRIBBLE_WITHBALL));
    //The player-> part lets us get at everything inside the Player object,
    //including the methods of BasicPlayer.  The ACT-> lets us do things
    //like record the soccer commands.  dribble is a method of BasicPlayer
    //that returns a SoccerCommand.
    return ACTIONS_SELECTED;
  }

  