/***************************************************************************
                          Level2.cpp  -  description
                             -------------------
    begin                : Tue Nov 26 2002
    copyright            : (C) 2002 by David Brokenshire
    email                : brokenshire@sfu.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "level2.h"
#include "Player.h"

  /*! Constructs the level with a reference to the player that own it.
  */
  Level2::Level2(Player* thePlayer) : Level()
  {
     player = thePlayer;
  }

  Level2::~Level2()
  {
  }

  LevelStateT Level2::execute()
  {
    if (getTimer() == 0)
      setTimer(6000);

    if (player->WM->getPlayerNumber() == player->WM->getCoordinatorNumber() )
    {
      if (player->WM->getTeamPossesion() != player->WM->getBallPossesion() )   // team possesion was changed
      {
       // cout<<"PossesChang"<<endl;
        return ACTIONS_UNSELECTED_FAILED;
      }

      if ( player->WM->getTeamPossesion() != POSSESION_NOTHING) // we need new TA if know ball possesion only
      {
        if (player->WM->isBallWithinRegion(REGION_T))   // the ball is inside the current target area
        {
         //cout<<"insideTA"<<endl;
         return ACTIONS_UNSELECTED_FAILED;
        }
        
       // if (player->WM->getBallPos().getDistanceTo(player->WM->getTargetArea()) > 50)
       // {
       //  cout<<"Too far"<<endl;
       //   return ACTIONS_UNSELECTED_FAILED;
       // }
      }
    }
   // else if (player->WM->isBallKickable() // the player has the ball but game mode is wrong
   //          && player->WM->getTeamPossesion()!=POSSESION_US)
   // {
   //   cout<<"conflict in level 2"<<endl;
   //   return ACTIONS_UNSELECTED_FAILED;   // go to the level 3
   // }
   
       
      
    player->multiCycleDribbleStep = 0;
    if (player->formations->getPlayerType() != PT_GOALKEEPER)
        player->setCurrentAction();  
    player->currentLevel--;
    return lowerLevel->execute();
  }