/***************************************************************************
                          Level3.cpp  -  description
                             -------------------
    begin                : Tue Nov 26 2002
    copyright            : (C) 2002 by David Brokenshire
    email                : brokenshire@sfu.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "level3.h"
#include "Player.h"

  /*! Constructs the level with a reference to the player that own it.
  */
  Level3::Level3(Player* thePlayer) : Level()
  {
     player = thePlayer;
     isBallInOurPossesion = POSSESION_NOTHING;
  }

  Level3::~Level3()
  {
  }

  LevelStateT Level3::execute()
  {
    if (getTimer() == 0)
      setTimer(6000);

    //player->setPlayerPossession();
    
    
    if (player->WM->getPlayerNumber() == player->WM->getCoordinatorNumber()) // If I am a coordinator (# 6 in this implementation)
    {
      player->WM->setTeamPossesion( player->WM->getBallPossesion() );
      
     if (player->WM->getTeamPossesion() == POSSESION_THEM)
     {
        //cout<<"defense"<<endl;
        player->WM->setTargetArea(player->WM->setTargetAreaDefense());
     }
     else if( player->WM->getTeamPossesion() == POSSESION_US)
     {
        //cout<<"offense"<<endl;
        player->WM->setTargetArea(player->WM->setTargetAreaOffense());
     }
     else
     {
       //cout<<"nothing"<<endl;
     }
     
     //cout<< player->WM->getTeamPossesion()<<endl;
     int nextCoordinator =player->WM->getCoordinatorNumber();     //always the same coordinator so far.
///// Vadim begin
     player->WM->bNeedToSayBall = true;   // force to send SayBall message with TA info
                                          // this patch for Target Area must be revised later
     player->WM->iSayBallMsgCode = player->WM->isTargetAreaOffence() ? -1 : -2;
/*
     player->ACT->sendCommandDirect(player->sayTargetArea( nextCoordinator,
                                    player->WM->getTeamPossesion(),
                                    player->WM->getTargetArea(),
                                    player->WM->isTargetAreaOffence()));
*/
//// Vadim end
    }
    //else if (player->WM->isBallKickable() // the player has the ball but game mode is wrong
    //       && player->WM->getTeamPossesion()!=POSSESION_US)
    //{
    //  cout<<"setting own TA l 3"<<endl;
    //  player->WM->setTeamPossesion( player->WM->getBallPossesion() );
    //  player->WM->setTargetArea(player->WM->setTargetAreaOffense()); // set own target area
    //}
        
    player->currentLevel--;
    return lowerLevel->execute();
  }

  void Level3::composeTargetAreaString(char* str)
  {
    if (str == NULL)
    { str = new char[50];
    }
    char side;
    if (player->WM->getSide() == SIDE_LEFT)
    { side = 'l';
    }
    else if (player->WM->getSide() == SIDE_RIGHT)
    { side = 'r';
    }
    else
    { side = 'i';
    }

    //AngDeg  bodyAng = player->WM->getAgentGlobalBodyAngle();
    //VecPosition bodyPos = player->WM->getAgentGlobalPosition();
    VecPosition target = player->WM->getTargetArea();
    VecPosition leftBottom;
    VecPosition rightTop;
    //target.setVecPosition(0.0, 0.0);
    leftBottom.setVecPosition(target.getX()-10.5,-target.getY()+10.5); // size of the target area
    rightTop.setVecPosition(target.getX()+11.3,-target.getY()-11.3);   // must be used here

    //leftBottom = leftBottom.globalToRelative(bodyPos, -bodyAng);
    //rightTop = rightTop.globalToRelative(bodyPos, -bodyAng);
    
    /*double ux = -player->WM->getPlayerNumber();
    double uy = player->WM->getPlayerNumber();
    double lx = player->WM->getPlayerNumber();
    double ly = -player->WM->getPlayerNumber();*/

    
    double ux = leftBottom.getX();
    double uy = leftBottom.getY();
    double lx = rightTop.getX();
    double ly = rightTop.getY();

            

    sprintf(str, "(%c %d %.2f %.2f %.2f %.2f)",side, player->WM->getPlayerNumber(),ux, uy, lx, ly);

  }


  // sets the variable indicates the team possession the ball

void  Level3::setTeamPossesion(PossesionT possesion)
{
  //if ( WM->isBallKickable() )
    //ifWePossessBall  = true;
  //else
   isBallInOurPossesion= possesion;

  return;
}

